/*
 * libkysdk-system's Library
 *
 * Copyright (C) 2023-2025, KylinSoft Co., Ltd.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library.  If not, see <https://www.gnu.org/licenses/>.
 *
 * Authors: Yunhe Liu <liuyunhe@kylinos.cn>
 *
 */

package com.kylin.kysdk;

import org.freedesktop.dbus.interfaces.DBusInterface;
import java.util.List;

public interface print extends DBusInterface {
    public List<String> getPrinterList();

    public List<String> getPrinterAvailableList();

    public void setPrinterOptions(int page,String paperType,String cups,String sided);

    public int getPrinterPrintLocalFile(String printer,String file);

    public int getPrinterCancelAllJobs(String printer);

    public int getPrinterStatus(String printer);

    public String getPrinterFilename(String url);

    public int getPrinterJobStatus(String job, int id);

    public int getPrinterDownloadRemoteFile(String remoteFile,String localFile);

}
