/*
 * libkysdk-system's Library
 *
 * Copyright (C) 2023-2025, KylinSoft Co., Ltd.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library.  If not, see <https://www.gnu.org/licenses/>.
 *
 * Authors: Yunhe Liu <liuyunhe@kylinos.cn>
 *
 */

#ifndef LOGROTATE_H
#define LOGROTATE_H

/**
 * @file logrotate.h
 * @author liuyunhe (liuyunhe@kylinos.cn)
 * @brief 日志转储
 * @version 0.1
 * @date 2022-12-28
 * 
 * @copyright Copyright (c) 2021
 * @defgroup libkysdk-logrotate
 * @{
 * @since 2.0.0.0
 */

#include <QObject>

class LogRotate : public QObject
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "com.kysdk.base.logrotate")
public:
    explicit LogRotate(QObject *parent = nullptr);

public slots:
    int setConfig(QString path);
};

#endif // LOGROTATE_H
